autogen.sh 8.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240
  1. #!/bin/sh
  2. #
  3. # ngIRCd -- The Next Generation IRC Daemon
  4. # Copyright (c)2001-2015 Alexander Barton (alex@barton.de) and Contributors
  5. #
  6. # This program is free software; you can redistribute it and/or modify
  7. # it under the terms of the GNU General Public License as published by
  8. # the Free Software Foundation; either version 2 of the License, or
  9. # (at your option) any later version.
  10. # Please read the file COPYING, README and AUTHORS for more information.
  11. #
  12. # Usage:
  13. # [VAR=<value>] ./autogen.sh [<configure-args>]
  14. #
  15. # This script generates the ./configure script using GNU automake and
  16. # GNU autoconf. It tries to be smart in finding the correct/usable/available
  17. # installed versions of these tools on your system.
  18. #
  19. # In addition, it enables or disables the "de-ANSI-fication" support of GNU
  20. # automake, which is supported up to autoconf 1.11.x an has been removed
  21. # in automake 1.12 -- make sure to use a version of automake supporting it
  22. # when generating distribution archives!
  23. #
  24. # The following strategy is used for each of aclocal, autoheader, automake,
  25. # and autoconf: first, "tool" (the regular name of the tool, e. g. "autoconf"
  26. # or "automake") is checked. If this fails, "tool<major><minor>" (for example
  27. # "automake16") and "tool-<major>.<minor>" (e. g. "autoconf-2.54") are tried
  28. # with <major> being 2 for tool of GNU autoconf and 1 for tools of automake;
  29. # <minor> is tried from 99 to 0. The first occurrence will be used.
  30. #
  31. # When you pass <configure-args> to autogen.sh it will call the generated
  32. # ./configure script on success and pass these parameters to it.
  33. #
  34. # You can tweak the behaviour using these environment variables:
  35. #
  36. # - ACLOCAL=<cmd>, AUTOHEADER=<cmd>, AUTOMAKE=<cmd>, AUTOCONF=<cmd>
  37. # Name and optionally path to the particular tool.
  38. # - PREFIX=<path>
  39. # Search the GNU autoconf and GNU automake tools in <path> first. If the
  40. # generated ./configure script will be called, pass "--prefix=<path>" to it.
  41. # - EXIST=<tool>
  42. # Use <tool> to test for aclocal, autoheader etc. pp. ...
  43. # When not specified, either "type" or "which" is used.
  44. # - VERBOSE=1
  45. # Output the detected names of the GNU automake and GNU autoconf tools.
  46. # - GO=1
  47. # Call ./configure even if no arguments have been passed to autogen.sh.
  48. #
  49. # Examples:
  50. #
  51. # - ./autogen.sh
  52. # Generates the ./configure script.
  53. # - GO=1 ./autogen.sh
  54. # Generates the ./configure script and runs it as "./configure".
  55. # - VERBOSE=1 ./autogen.sh --with-ident
  56. # Show tool names, generates the ./configure script, and runs it with
  57. # these arguments: "./configure --with-ident".
  58. # - ACLOCAL=aclocal-1.6 GO=1 PREFIX=$HOME ./autogen.sh
  59. # Uses "aclocal-1.6" as aclocal tool, generates the ./configure script,
  60. # and runs it with these arguments: "./configure --prefix=$HOME".
  61. #
  62. Search()
  63. {
  64. [ $# -eq 2 ] || exit 1
  65. searchlist="$1"
  66. major="$2"
  67. minor=99
  68. [ -n "$PREFIX" ] && searchlist="${PREFIX}/$1 ${PREFIX}/bin/$1 $searchlist"
  69. for name in $searchlist; do
  70. $EXIST "${name}" >/dev/null 2>&1
  71. if [ $? -eq 0 ]; then
  72. "${name}" --version 2>&1 \
  73. | grep -v "environment variable" >/dev/null 2>&1
  74. if [ $? -eq 0 ]; then
  75. echo "${name}"
  76. return 0
  77. fi
  78. fi
  79. done
  80. while [ $minor -ge 0 ]; do
  81. for name in $searchlist; do
  82. $EXIST "${name}${major}${minor}" >/dev/null 2>&1
  83. if [ $? -eq 0 ]; then
  84. echo "${name}${major}${minor}"
  85. return 0
  86. fi
  87. $EXIST "${name}-${major}.${minor}" >/dev/null 2>&1
  88. if [ $? -eq 0 ]; then
  89. echo "${name}-${major}.${minor}"
  90. return 0
  91. fi
  92. done
  93. minor=$(expr $minor - 1)
  94. done
  95. return 1
  96. }
  97. Notfound()
  98. {
  99. echo "Error: $* not found!"
  100. echo "Please install recent versions of GNU autoconf and GNU automake."
  101. exit 1
  102. }
  103. Run()
  104. {
  105. [ "$VERBOSE" = "1" ] && echo " - running \"$*\" ..."
  106. "$@"
  107. }
  108. # Reset locale settings to suppress warning messages of Perl
  109. unset LC_ALL
  110. unset LANG
  111. # Which command should be used to detect the automake/autoconf tools?
  112. [ -z "$EXIST" ] && existlist="type which" || existlist="$EXIST"
  113. EXIST=""
  114. for t in $existlist; do
  115. $t /bin/ls >/dev/null 2>&1
  116. if [ $? -eq 0 ]; then
  117. rm -f /tmp/test.$$
  118. $t /tmp/test.$$ >/dev/null 2>&1
  119. [ $? -ne 0 ] && EXIST="$t"
  120. fi
  121. [ -n "$EXIST" ] && break
  122. done
  123. if [ -z "$EXIST" ]; then
  124. echo "Didn't detect a working command to test for the autoconf/automake tools!"
  125. echo "Searchlist: $existlist"
  126. exit 1
  127. fi
  128. [ "$VERBOSE" = "1" ] && echo "Using \"$EXIST\" to test for tools."
  129. # Try to detect the needed tools when no environment variable already
  130. # specifies one:
  131. echo "Searching for required tools ..."
  132. [ -z "$ACLOCAL" ] && ACLOCAL=$(Search aclocal 1)
  133. [ "$VERBOSE" = "1" ] && echo " - ACLOCAL=$ACLOCAL"
  134. [ -z "$AUTOHEADER" ] && AUTOHEADER=$(Search autoheader 2)
  135. [ "$VERBOSE" = "1" ] && echo " - AUTOHEADER=$AUTOHEADER"
  136. [ -z "$AUTOMAKE" ] && AUTOMAKE=$(Search automake 1)
  137. [ "$VERBOSE" = "1" ] && echo " - AUTOMAKE=$AUTOMAKE"
  138. [ -z "$AUTOCONF" ] && AUTOCONF=$(Search autoconf 2)
  139. [ "$VERBOSE" = "1" ] && echo " - AUTOCONF=$AUTOCONF"
  140. AUTOCONF_VERSION=$(echo "$AUTOCONF" | cut -d'-' -f2-)
  141. [ -n "$AUTOCONF_VERSION" ] && [ "$AUTOCONF_VERSION" != "autoconf" ] \
  142. && export AUTOCONF_VERSION || unset AUTOCONF_VERSION
  143. [ "$VERBOSE" = "1" ] && echo " - AUTOCONF_VERSION=$AUTOCONF_VERSION"
  144. AUTOMAKE_VERSION=$(echo $AUTOMAKE | cut -d'-' -f2-)
  145. [ -n "$AUTOMAKE_VERSION" ] && [ "$AUTOMAKE_VERSION" != "automake" ] \
  146. && export AUTOMAKE_VERSION || unset AUTOMAKE_VERSION
  147. [ "$VERBOSE" = "1" ] && echo " - AUTOMAKE_VERSION=$AUTOMAKE_VERSION"
  148. [ $# -gt 0 ] && CONFIGURE_ARGS=" $*" || CONFIGURE_ARGS=""
  149. [ -z "$GO" ] && [ -n "$CONFIGURE_ARGS" ] && GO=1
  150. # Verify that all tools have been found
  151. [ -z "$ACLOCAL" ] && Notfound aclocal
  152. [ -z "$AUTOHEADER" ] && Notfound autoheader
  153. [ -z "$AUTOMAKE" ] && Notfound automake
  154. [ -z "$AUTOCONF" ] && Notfound autoconf
  155. AM_VERSION=$($AUTOMAKE --version | head -n 1 | sed -e 's/.* //g')
  156. ifs=$IFS; IFS="."; set $AM_VERSION; IFS=$ifs
  157. AM_MAJOR="$1"; AM_MINOR="$2"
  158. echo "Detected automake $AM_VERSION ..."
  159. AM_MAKEFILES="src/ipaddr/Makefile.ng src/ngircd/Makefile.ng src/testsuite/Makefile.ng src/tool/Makefile.ng"
  160. # De-ANSI-fication?
  161. if [ "$AM_MAJOR" -eq "1" ] && [ "$AM_MINOR" -lt "12" ]; then
  162. # automake < 1.12 => automatic de-ANSI-fication support available
  163. echo " - Enabling de-ANSI-fication support."
  164. sed -e "s|^__ng_PROTOTYPES__|AM_C_PROTOTYPES|g" configure.ng >configure.ac
  165. DEANSI_START=""
  166. DEANSI_END=""
  167. else
  168. # automake >= 1.12 => no de-ANSI-fication support available
  169. echo " - Disabling de-ANSI-fication support."
  170. sed -e "s|^__ng_PROTOTYPES__|AC_C_PROTOTYPES|g" configure.ng >configure.ac
  171. DEANSI_START="#"
  172. DEANSI_END=" (disabled by ./autogen.sh script)"
  173. fi
  174. # Serial test harness?
  175. if [ "$AM_MAJOR" -eq "1" ] && [ "$AM_MINOR" -ge "13" ]; then
  176. # automake >= 1.13 => enforce "serial test harness"
  177. echo " - Enforcing serial test harness."
  178. SERIAL_TESTS="serial-tests"
  179. else
  180. # automake < 1.13 => no new test harness, nothing to do
  181. # shellcheck disable=SC2034
  182. SERIAL_TEST=""
  183. fi
  184. sed -e "s|^__ng_Makefile_am_template__|AUTOMAKE_OPTIONS = ${SERIAL_TESTS} ${DEANSI_START}ansi2knr${DEANSI_END}|g" \
  185. src/portab/Makefile.ng >src/portab/Makefile.am
  186. for makefile_ng in $AM_MAKEFILES; do
  187. makefile_am=$(echo "$makefile_ng" | sed -e "s|\.ng\$|\.am|g")
  188. sed -e "s|^__ng_Makefile_am_template__|AUTOMAKE_OPTIONS = ${SERIAL_TESTS} ${DEANSI_START}../portab/ansi2knr${DEANSI_END}|g" \
  189. $makefile_ng >$makefile_am
  190. done
  191. export ACLOCAL AUTOHEADER AUTOMAKE AUTOCONF
  192. # Generate files
  193. echo "Generating files using \"$AUTOCONF\" and \"$AUTOMAKE\" ..."
  194. Run $ACLOCAL && \
  195. Run $AUTOCONF && \
  196. Run $AUTOHEADER && \
  197. Run $AUTOMAKE --add-missing --no-force
  198. if [ $? -eq 0 ] && [ -x ./configure ]; then
  199. # Success: if we got some parameters we call ./configure and pass
  200. # all of them to it.
  201. NAME=$(grep PACKAGE_STRING= configure | cut -d"'" -f2)
  202. if [ "$GO" = "1" ]; then
  203. [ -n "$PREFIX" ] && p=" --prefix=$PREFIX" || p=""
  204. c="./configure${p}${CONFIGURE_ARGS}"
  205. echo "Okay, autogen.sh for $NAME done."
  206. echo "Calling \"$c\" ..."
  207. $c
  208. exit $?
  209. else
  210. echo "Okay, autogen.sh for $NAME done."
  211. echo "Now run the \"./configure\" script."
  212. exit 0
  213. fi
  214. else
  215. # Failure!?
  216. echo "Error! Check your installation of GNU automake and autoconf!"
  217. exit 1
  218. fi
  219. # -eof-